type BrowserFP = { browser: string };

type VideoCardFP = {
	vendor: string;
	vendorUnmasked: string;
	renderer: string;
	rendererUnmasked: string;
	version: string;
	shadingLanguageVersion: string;
};

type HardwareFP = {
	hardware: {
		videocard: VideoCardFP;
		architecture: number;
		deviceMemory: string;
		jsHeapSizeLimit: number;
	};
};

type CanvasFP = {
	canvas: {
		data: string;
	};
};

type AudioFP = {
	audio: {
		sampleHash: string;
		oscillator: string;
		maxChannels: number;
		channelCountMode: string;
	};
};

type SystemFP = {
	system: {
		platform: string;
		cookieEnabled: boolean;
		productSub: string;
		product: string;
	};
};

type LocalesFP = {
	locales: {
		languages: string;
		timezone: string;
	};
};

type ScreenFP = {
	screen: {
		colorDepth: number;
		pixelDepth: number;
		isTouchScreen: boolean;
		maxTouchPoints: number;
		mediaMatches: string[];
	};
};

type FontsFP = string[];

type FingerprintData = [
    AudioFP,
    BrowserFP,
    CanvasFP,
    FontsFP,
    HardwareFP,
    LocalesFP,
    ScreenFP,
    SystemFP
];
declare const getFingerprintData: (debug?: boolean) => Promise<FingerprintData>;
declare const getFingerprintHash: (debug?: boolean) => Promise<string>;

export { getFingerprintData, getFingerprintHash };
